EPGPRaidAttendance = LibStub("AceAddon-3.0"):NewAddon("EPGPRaidAttendance", "AceConsole-3.0", "AceEvent-3.0", "AceTimer-3.0");

EPGPRaidAttendanceConfig = {}

local descriptionMenu = {
  name = "EPGPRaidAttendance",
  type = "group",
  args = {
    intro1 = {
      order = 0,
      type = "description",
      name = "Get Attendance from EPGP:\n\nThis addon reads EPGP log to find 'approximated' attendance for players and output to desired channel.\n",
    },
        
    intro2 = {
      order = 1,
      type = "description",
      name = "- How its works?\n\nThe addon scan EPGP log for the desired <keywords> (usually EPGP reasons for been on time in raid), and count the times that a player gets if per raid.\n",
    },
    
	intro3 = {
      order = 2,
      type = "description",
      name = "- Its accurate?\n\nNOT, this its approximation of attendance thats take only into account been on time for raid, its just a guide for officers.\n",
    },    
    
    intro4 = {
      order = 3,
      type = "description",
      name = "- Why all raids are non shown?\n\nEPGP log its recored per account when you are online in the guild, that means that if your where not online with any char in the guild at raid time, you will not get your log fullfiled.\n",
    },                          
    
    intro5 = {
      order = 4,
      type = "description",
      name = "- Conclusion:\n\nThis tool used by a officer that usually been on time in raid will get a approximation about the attendance for other players.\n",
    },  
  }
}

local slashMenu = {
  name = "Slash Commands",
  type = "group",
  
	args = {		    
	
		intro = {
	      order = 0,
	      type = "description",
	      name = "Open config: /epgpa\n",
	    },  	       	
	    	
	    intro1 = {
	      order = 1,
	      type = "description",
	      name = "List raids: /epgpa raids\n",
	    },  	       	
	    
		intro2 = {
	      order = 2,
	      type = "description",
	      name = "Raid details: /epgpa raid <raidnum>\n",
	    },  
	    	       		    
	    intro3 = {
	      order = 3,
	      type = "description",
	      name = "Char details: /epgpa char <char name>\n",
	    },  	    
	    
	    intro4 = {
	      order = 4,
	      type = "description",
	      name = "Find char raids: /epgpa find <char name>\n",
	    },  
	    	    
	}			    
	
}

local actionsMenu ={

  name = "Execute actions",
  type = "group",
  
  args = {
  
	ListRaid = {
		order = 13,
		type = "execute",		
		name = "List Raids",
		desc = "List stored raids (/epgpa raids)",
		func = "ListRaid",
		handler = EPGPRaidAttendance,
		width = "double",
	},    
	
	Raidnum = {
		order = 14,
		type = "input",
		name = "Raid Number",
		desc = "Sets the raid number for query",
		get = function() return EPGPRaidAttendanceConfig.Raidnum end,
		set = function(_,v) EPGPRaidAttendanceConfig.Raidnum = v end,
	},   	
	
	RaidDetail = {
		order = 15,
		type = "execute",		
		name = "Raid Detail",
		desc = "Get raid detail (/epgpa raid <num>)",
		func = "RaidDetail",
		handler = EPGPRaidAttendance,
	},   	
	
	Charname = {
		order = 16,
		type = "input",
		name = "Char Name",
		desc = "Sets the char name for query",
		get = function() return EPGPRaidAttendanceConfig.Charname end,
		set = function(_,v) EPGPRaidAttendanceConfig.Charname = v end,
	},   	
	
	CharDetail = {
		order = 17,
		type = "execute",		
		name = "Char Detail",
		desc = "Get char detail (/epgpa char <name>)",
		func = "CharDetail",
		handler = EPGPRaidAttendance,
	}, 	
	
	FindRaids = {
		order = 18,
		type = "execute",		
		name = "Find Raids",
		desc = "Find raids(/epgpa find <name>)",
		func = "FindRaids",
		handler = EPGPRaidAttendance,
	}, 		
  
  }
  
}

local options = {
  name = "Configuration",
  type = "group",
  args = {
    
    intro7 = {
      order = 7,
      type = "description",
      name = "List store raids",
    },         

        
    
	Keyword = {
		order = 10,
		type = "input",
		name = "Attendance Keywords",
		desc = "Sets the attendance keywords (comma separated)",
		get = function() return EPGPRaidAttendanceConfig.Keyword end,
		set = function(_,v) EPGPRaidAttendanceConfig.Keyword = v end,
	},    
	
	
	OutputChat = {
		type = "select",
		name = "Output messages to",
      	desc = "Set the output chat channel for messages",
		get = function() return EPGPRaidAttendanceConfig.OutputChat end,
		set = function(_,v) EPGPRaidAttendanceConfig.OutputChat = v end,
		arg = nil,
		style = "dropdown",
		width = "full",
		values = {
			SELF="Only to self",
			GUILD="Guild chat",
			PARTY="Party",
			RAID="Raid",
			RAID_WARNING="Raid Warning",
			OFFICER="Officer chat"
		},
		order =11,
	},
	    
			
  },
}


function EPGPRaidAttendance:ListRaid()
	ListOption("raids")
end

function EPGPRaidAttendance:RaidDetail()
	ListOption("raid "..EPGPRaidAttendanceConfig.Raidnum)
end

function EPGPRaidAttendance:CharDetail()
	ListOption("char "..EPGPRaidAttendanceConfig.Charname)
end

function EPGPRaidAttendance:FindRaids()
	ListOption("find "..EPGPRaidAttendanceConfig.Charname)
end



--LibStub("AceConfig-3.0"):RegisterOptionsTable("EPGPRaidAttendance", options);
--EPGPRaidAttendance.PrefPane = LibStub("AceConfigDialog-3.0"):AddToBlizOptions("EPGPRaidAttendance");

  registry = LibStub("AceConfigRegistry-3.0");
  registry:RegisterOptionsTable("EPGPRaidAttendance", descriptionMenu);
  registry:RegisterOptionsTable("Slash", slashMenu);
  registry:RegisterOptionsTable("Config", options);
  registry:RegisterOptionsTable("Actions", actionsMenu);
  
  
  
  EPGPRaidAttendance.PrefPane = LibStub("AceConfigDialog-3.0");
  
  EPGPRaidAttendance.mainOptions = EPGPRaidAttendance.PrefPane:AddToBlizOptions("EPGPRaidAttendance","EPGPRaidAttendance")
  EPGPRaidAttendance.PrefPane:AddToBlizOptions("Actions", "Execute Actions","EPGPRaidAttendance")
  EPGPRaidAttendance.PrefPane:AddToBlizOptions("Slash","Slash Commands","EPGPRaidAttendance")
  EPGPRaidAttendance.PrefPane:AddToBlizOptions("Config", "Configuration","EPGPRaidAttendance")
  
  
  


local defaults = {
	Keyword = "raid begin,raid start",
	OutputChat ="SELF",
	Raidnum = "",
	Charname = ""
}

function EPGPRaidAttendance:OnInitialize()
  setmetatable(EPGPRaidAttendanceConfig, {__index = defaults})
end

function EPGPRaidAttendance:OnDisable()
    self:UnregisterAllEvents()
end


function EPGPRaidAttendance:OnEnable()
	
    self:RegisterChatCommand("EPGPRaidAttendance", function() InterfaceOptionsFrame_OpenToCategory(EPGPRaidAttendance.mainOptions); end)
    
    self:RegisterChatCommand("epgpa", 
    	function(o) 
    		if(o=="") then
		   		InterfaceOptionsFrame_OpenToCategory(EPGPRaidAttendance.mainOptions)
		   	else
		   	 	ListOption(o)
		   	end
    	end)

	EPGPRaidAttendance:Print("EPGP Attendance Addon loaded.")

end

EPGP = LibStub("AceAddon-3.0"):GetAddon("EPGP")
EPGPlog = EPGP:GetModule("log");

function strout(str)
	if EPGPRaidAttendanceConfig.OutputChat=="SELF" then
		EPGPRaidAttendance:Print(str);
	else
		SendChatMessage("EPGPRaidAttendance: "..str,EPGPRaidAttendanceConfig.OutputChat);
	end
	
end

-- log format aaaa-dd-mm hh:mm +/-amount (reason) to char

function ListOption(option)
	EPGPRaidAttendance:Print(" processing....")
	local numRecords = EPGPlog:GetNumRecords()
	
	lastlogdate = ""
	
	raidcount = 0
	raids = {}
	raidschars = {}
	
	raidassist = {}
	charfirstraid = {}
	
	for i=0,numRecords-1 do
		logline = EPGPlog:GetLogRecord(i)
		
		
		found = false
		
		keys = {strsplit(",",EPGPRaidAttendanceConfig.Keyword)}
		
		table.foreach(keys, function(k,v) 
			
			if not (strfind(strlower(logline),strlower(v))==nil) then
				found = true
			end
							
		end);
		
		
		if found then
						
			logdate = strsub(logline,0,10) -- only get one raid per day
			if not(logdate==lastlogdate) then							
				
				lastlogdate=logdate
				
				raids[raidcount] = logdate
				raidschars[raidcount]= ""
				
				raidcount=raidcount+1
																
			end
			
			pos = strfind(logline,") to ")+5
			logchar = strsub(logline,pos)
			
			raidschars[raidcount-1] = raidschars[raidcount-1] .. logchar .. ","
			
			if (raidassist[logchar] == nil) then
				raidassist[logchar] = 0				
			end
			charfirstraid[logchar] = raidcount
			
			raidassist[logchar] = raidassist[logchar] + 1
			
		end
		
	end
	
	EPGPRaidAttendance:Print(" processed.")
	
	--EPGPRaidAttendance:Print("Option..."..option)
	
	if (strsub(option,0,5)=="raids") then
	
		strout(" total raids : "..raidcount)
		
	elseif (strsub(option,0,4)=="raid") then
	
		raidnum = strsub(option,5)
		if not ( raidnum == nil) then
			raidnum = tonumber(raidnum)
			if not ( raidnum == nil) then
				if (raidnum < 1) or (raidnum > raidcount) then
				
					EPGPRaidAttendance:Print(" invalid raid number")
					
				else
								
					strout(" Raid "..raidnum.." :" .. raids[raidcount-raidnum])
					strout("chars: "..raidschars[raidcount-raidnum])				  
				
				end
			end
		end 
	
	elseif (strsub(option,0,4)=="char") then		
		charname = strsub(option,6)
		
		if charfirstraid[charname]==nil then
		
			EPGPRaidAttendance:Print(" ["..charname.."] is not found in raid history")
		
		else			
			
			firstraid = charfirstraid[charname]-1
			
			possibleraids = charfirstraid[charname]
					
			assit = (raidassist[charname]*100) / possibleraids
			assit = string.format("%.2f", assit)				
			
			strout(charname..' assist to '..raidassist[charname].." ("..assit.."%) of "..possibleraids.." raids, since "..raids[firstraid]); 		
		
		end 
	elseif (strsub(option,0,4)=="find") then		
		charname = strsub(option,6)
		
		if charfirstraid[charname]==nil then
		
			EPGPRaidAttendance:Print(" ["..charname.."] is not found in raid history")
		
		else
			strraids = charname .." assist to raids: "
	
			for i=1,raidcount do		
			
				charslist = raidschars[raidcount-i]
				
				
				if not(strfind(charslist,charname..",")==nill) then
					strraids = strraids..i..","		  
				end
			end
			strout(strraids)
		end		
		
	end
	
	--for i=1,raidcount do
	
	--	EPGPRaidAttendance:Print("Raid "..i.." :" .. raids[raidcount-i])
	--	EPGPRaidAttendance:Print("Chars: "..raidschars[raidcount-i])				  
	--end
	
	--table.foreach(raidassist, function(k,v) 
	
	--	firstraid = charfirstraid[k]-1
		
	--	possibleraids = charfirstraid[k]
				
	--	assit = (v*100) / possibleraids
	--	assit = string.format("%.2f", assit)
		
		--EPGPRaidAttendance:Print("Char "..k.." assist to ".. v .." total " .. raidcount .. " posibles " .. possibleraids)
		
		
	--	EPGPRaidAttendance:Print("Char "..k..' assist to '..v.."("..assit.."%) raids of "..possibleraids..", since "..raids[firstraid]); 
	
	--end);
	
end